﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ConsoleApplication12
{
    class Program
    {
        static void Main(string[] args)
        {
            RetryHelper helper=RetryHelper.Make();

            helper.CreateNodeStructure = () => { Console.WriteLine("CreateNodeStructure"); };
            helper.FixConnectionLossAction = () => 
            { 
                Console.WriteLine(Thread.CurrentThread.ManagedThreadId+" FixConnectionLossAction BEGIN "+DateTime.Now.ToString());
                Thread.Sleep(2000);
                Console.WriteLine(Thread.CurrentThread.ManagedThreadId + " FixConnectionLossAction END " + DateTime.Now.ToString());
            };
            helper.IfErrorThen = () => { Console.WriteLine("IfErrorThen"); };

            var tasks=new List<Task>();
            for (int i = 0; i < 10; i++)
            {
                var task = new Task(() => {
                    helper.Execute(() =>
                    {
                        throw new ZooKeeperNet.KeeperException.ConnectionLossException();
                    });
                });
                tasks.Add(task);
            }

            tasks.ForEach(t=>t.Start());

            Task.WaitAll(tasks.ToArray());

            Console.ReadKey();
        }

    }
}
